#include "sortlib.h"


// Schnittstelle A ist ein Array von A[0] bis A[max]
// d.h. mit max+1 Elementen  

void InitIntAr (intar A, int max) 
{ // Initialisiere das Array A mit zuflligen Werten
srand(42); // seed
for (int i = 0; i <= max; i++) A[i] = rand();
}

void CopyIntAr (intar Quelle, intar Ziel, int max) 
{ // Kopiere Quelle -> Ziel
  // for (int i = 0; i <= max; i++) Ziel[i] = Quelle[i];
  memcpy(Ziel, Quelle, (max+1)*sizeof(int));
}


int TestAr (intar A, int max) 
{ // Initialisiere ob die Elemente des Array A sortiert sind
int erg = 1;
for (int i = 0; i < max; i++) if (A[i] > A[i+1]) {erg =0; break;};
return erg;
}


void InsertionSort (intar A, int max) 
{  for ( int k = 1; k <= max; k++ )
     { if ( A[k] < A[k-1]) 
        {	int x  = A[k];
    		for (int i = k; ( (i > 0) && (A[i-1]> x) ); i--)
               A[i] = A[i-1];
         	A[i] = x;
        }
      };    
}

void ShellSort (intar A, int max) 
{ int hmax, h ;
  for (	hmax = 1; hmax < max ; hmax = 3*hmax+1 );
  for ( h = hmax/3; h >= 1; h /= 3) 
    for ( int k = h; k <= max; k++ )
     {
        if ( A[k] < A[k-h]) 
        {	int x  = A[k];
    		for (int i = k; ( (i > (h-1)) && (A[i-h]> x) ); i-=h)
                A[i] = A[i-h];
         	A[i] = x;
        }
      };    
}

inline int By1 (int x) { return (  x        & 0xff); }
inline int By2 (int x) { return ( (x >>  8) & 0xff); }
inline int By3 (int x) { return ( (x >> 16) & 0xff); }
inline int By4 (int x) { return ( (x >> 24) & 0xff); }


void DistributionSort (intar A, int max) 
{ int Count[256];
  int i;

  typedef int* intP;	
  // intarPtr B = intarPtr(calloc(max+1, sizeof(int)));
  intP B = new int[max+1];
  CopyIntAr (A, B, max);
  

  // Byte 1
  for (i=0; i < 256; i++) Count[i] = 0;
  for (i=0; i <= max; i++) // Zhlen
      (Count[ By1(A[i]) ])++;
  for (i=1; i < 256; i++) // Aufsummieren
       Count[i] += Count[i-1];
  for (i=max; i >= 0; i--) // Verteilen
		B[--(Count[By1(A[i])])] = A[i];
	  
  CopyIntAr (B, A, max);
   

  // Byte 2
  for (i=0; i < 256; i++) Count[i] = 0;
  for (i=0; i <= max; i++) // Zhlen
      (Count[ By2(A[i]) ])++;
  for (i=1; i < 256; i++) // Aufsummieren
       Count[i] += Count[i-1];
  for (i=max; i >= 0; i--) // Verteilen
      B[--(Count[By2(A[i])])] = A[i];
  CopyIntAr (B, A, max);

  // Byte 3
  for (i=0; i < 256; i++) Count[i] = 0;
  for (i=0; i <= max; i++) // Zhlen
      (Count[ By3(A[i]) ])++;
  for (i=1; i < 256; i++) // Aufsummieren
       Count[i] += Count[i-1];
  for (i=max; i >= 0; i--) // Verteilen
      B[--(Count[By3(A[i])])] = A[i];
  CopyIntAr (B, A, max);

  // Byte 4
  for (i=0; i < 256; i++) Count[i] = 0;
  for (i=0; i <= max; i++) // Zhlen
      (Count[ By4(A[i]) ])++;
  for (i=1; i < 256; i++) // Aufsummieren
       Count[i] += Count[i-1];
  for (i=max; i >= 0; i--) // Verteilen
     B[--(Count[By4(A[i])])] = A[i];
  CopyIntAr (B, A, max);

}

