import java.util.*;

class Heap<E extends Comparable<E>>{
    
    E[] theHeap;
    private int maxHeapPos;
    private int nextPos;
    
    Heap(int max){
    	maxHeapPos = max;
    	nextPos=0;
    	theHeap = ( E[] ) new Object[max];
    	
    }
    
    private final void swap(int i, int k){
        E temp = theHeap[i];
        theHeap[i] = theHeap[k];
        theHeap[k] = temp;
        }

     boolean istLeer(){ return nextPos == 0;}
     
     
     void insertHeap(E ... el) throws Exception{
     	for (E e : el)insertHeap(e);
      }
      
     void insertHeap(E e) throws Exception{
     	if (nextPos==maxHeapPos) throw new Exception("Heap Full");
     	theHeap[nextPos] = e; 
     	upHeap(nextPos);
      nextPos++;
      }
      
     private void upHeap(int sohn){
				int vater = (sohn-1)/2;
				if (theHeap[vater].compareTo(theHeap[sohn]) < 0){
					 swap(vater,sohn);
					 upHeap(vater);
					}
			}
			
			E getNext(){
				if (istLeer()) return null;
				E result = theHeap[0];
				nextPos--;
				theHeap[0] = theHeap[nextPos];
				downHeap(0);
				return result;
			}

     
		private void downHeap(int vater){
				int lSohn = 2*vater+1;
				int rSohn = lSohn+1;
				if (lSohn >= nextPos) return; // keine Shne da!
				if (rSohn == nextPos){ // nur linker Sohn da
					if (theHeap[vater].compareTo(theHeap[lSohn]) < 0)
					  swap(vater,lSohn);
					  return;
					}
					else{
						int maxSohn = (theHeap[rSohn].compareTo(theHeap[lSohn])  < 0) ? lSohn : rSohn;
						if (theHeap[maxSohn].compareTo(theHeap[vater]) > 0) return;
						else{
							swap(vater,maxSohn);
							downHeap(maxSohn);
						}
				  }
			  } 
    
    public String toString(){  
      StringBuilder sb = new StringBuilder() ;
      for (int i=0; i < nextPos;i++) sb.append(theHeap[i]+" ");
      return sb.toString();
     }	

    public static void main(String ... args) throws Exception{
     Heap<Character> myHeap = new Heap<Character>(100);
     myHeap.insertHeap('W','S','P','F','G','A','M','D','B','C');
     //myHeap.insertHeap('A', 'D','B','C','W','S','P','F','G','M');
     System.out.println(myHeap);
     myHeap.insertHeap('T');
     System.out.println(myHeap);
     
     System.out.println(myHeap.getNext());
     System.out.println(myHeap);
     while(!myHeap.istLeer()){
     	 System.out.println(myHeap.getNext());
     	 System.out.println(myHeap);
      }
    }
}
